<?php if (!defined('APPLICATION')) exit();

// Define the plugin:
$PluginInfo['TopPosters'] = array(
   'Name' => 'TopPosters',
   'Description' => "Lists those users with most posted comment (sidepanel)",
   'Version' => '1.3.1',
   'Author' => "Adrian Lee",
   'AuthorEmail' => 'l33.adrian@gmail.com',
   'AuthorUrl' => 'http://www.pinoyau.info',   
   'SettingsPermission' => FALSE
);

class TopPostersPlugin extends Gdn_Plugin {
   
   public function PluginController_TopPosters_Create(&$Sender) {
      $Sender->AddSideMenu('plugin/topposters');
      $Sender->Form = new Gdn_Form();
      $Validation = new Gdn_Validation();
      $ConfigurationModel = new Gdn_ConfigurationModel($Validation);
      $ConfigurationModel->SetField(array('TopPosters.Location.Show', 'TopPosters.Limit', 'TopPosters.Excluded'));
      $Sender->Form->SetModel($ConfigurationModel);
            
      if ($Sender->Form->AuthenticatedPostBack() === FALSE) {    
         $Sender->Form->SetData($ConfigurationModel->Data);    
      } else {
         $Data = $Sender->Form->FormValues();
         $ConfigurationModel->Validation->ApplyRule('TopPosters.Limit', array('Required', 'Integer'));
         $ConfigurationModel->Validation->ApplyRule('TopPosters.Location.Show', 'Required');
         if ($Sender->Form->Save() !== FALSE)
            $Sender->StatusMessage = Gdn::Translate("Your settings have been saved.");
      }
	  $TopPostersModule = new TopPostersModule($Sender);	  
	  $Sender->AllUsers = $TopPostersModule->GetAllUsers();
      $Sender->Render($this->GetView('topposters.php'));
   }

   public function Base_Render_Before(&$Sender) {
      $ConfigItem = Gdn::Config('TopPosters.Location.Show', 'every');
      $Controller = $Sender->ControllerName;
      $Application = $Sender->ApplicationFolder;
      $Session = Gdn::Session();     		
		
		$ShowOnController = array();		
		switch($ConfigItem) {
			case 'every':
				$ShowOnController = array(
					'discussioncontroller',
					'categoriescontroller',
					'discussionscontroller',
					'profilecontroller',
					'activitycontroller',
					'draftscontroller'
				);
				break;
			case 'discussion':
			default:
				$ShowOnController = array(
					'discussioncontroller',
					'discussionscontroller',
					'categoriescontroller',
					'draftscontroller'
				);				
		}
		if (!InArrayI($Controller, $ShowOnController)) return;	  
		include_once(PATH_PLUGINS.DS.'TopPosters'.DS.'class.toppostersmodule.php');
		$TopPostersModule = new TopPostersModule($Sender);
		$TopPostersModule->GetData();	   
		$Sender->AddModule($TopPostersModule);
		$Limit = Gdn::Config('TopPosters.Limit', 4);
		if (!is_numeric($Limit)) $Limit = 4;      
		$Sender->AddDefinition('TopPostersLimit', $Limit);      
   }

   public function Base_GetAppSettingsMenuItems_Handler(&$Sender) {
      $Menu = $Sender->EventArguments['SideMenu'];
      $Menu->AddLink('Add-ons', 'Top Posters', 'plugin/topposters', 'Garden.Themes.Manage');
   }   

   public function Setup() { 
     //nothing to do here
   }
}
